Require map_coq.
Require Max.
Require Compare_dec.

Extract Inductive unit => unit [ "()" ].
Extract Inductive bool => bool [ true false ].
Extract Inductive sumbool => bool [ true false ].
Extract Inductive prod => pair [ "" ].
Extract Inductive option => option [ Some None ].

Extract Inductive nat => int [ "0" succ ].

Extract Inlined Constant le_gt_dec => "( <= )".
Extract Inlined Constant le_lt_dec => "( <= )".
Extract Inlined Constant max => max.

Extract Inlined Constant key => key.
Extract Inlined Constant compare => compare.
Extract Inlined Constant physical_equal => "( == )".

Extract Inductive compare_result => compare_result [ LESS EQUAL GREATER].

Extraction "map_coq_core.ml" coqadd coqfind coqremove map mapi map2inz map2iz.
